Index: trunk/src/VBox/Runtime/Makefile.kmk
===================================================================
--- trunk/src/VBox/Runtime/Makefile.kmk	(revision 10948)
+++ trunk/src/VBox/Runtime/Makefile.kmk	(revision 10949)
@@ -196,4 +196,6 @@
 	common/misc/thread.cpp \
 	common/misc/zip.cpp \
+	common/string/RTStrNLen.cpp \
+	common/string/RTStrNLenEx.cpp \
 	common/string/straprintf.cpp \
 	common/string/strformat.cpp \
Index: trunk/src/VBox/Runtime/common/string/RTStrNLen.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/string/RTStrNLen.cpp	(revision 10949)
+++ trunk/src/VBox/Runtime/common/string/RTStrNLen.cpp	(revision 10949)
@@ -0,0 +1,42 @@
+/* $Id$ */
+/** @file
+ * IPRT - RTStrNLen.
+ */
+
+/*
+ * Copyright (C) 2008 Sun Microsystems, Inc.
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * The contents of this file may alternatively be used under the terms
+ * of the Common Development and Distribution License Version 1.0
+ * (CDDL) only, as it comes in the "COPYING.CDDL" file of the
+ * VirtualBox OSE distribution, in which case the provisions of the
+ * CDDL are applicable instead of those of the GPL.
+ *
+ * You may elect to license modified versions of this file under the
+ * terms and conditions of either the GPL or the CDDL or both.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
+ */
+
+/*******************************************************************************
+*   Header Files                                                               *
+*******************************************************************************/
+#include <iprt/string.h>
+
+
+RTDECL(size_t) RTStrNLen(const char *pszString, size_t cchMax)
+{
+    const char *pchEnd = (const char *)memchr(pszString, '\0', cchMax);
+    return pchEnd ? pchEnd - pszString : cchMax;
+}
+
Index: trunk/src/VBox/Runtime/common/string/RTStrNLenEx.cpp
===================================================================
--- trunk/src/VBox/Runtime/common/string/RTStrNLenEx.cpp	(revision 10949)
+++ trunk/src/VBox/Runtime/common/string/RTStrNLenEx.cpp	(revision 10949)
@@ -0,0 +1,48 @@
+/* $Id$ */
+/** @file
+ * IPRT - RTStrNLenEx.
+ */
+
+/*
+ * Copyright (C) 2008 Sun Microsystems, Inc.
+ *
+ * This file is part of VirtualBox Open Source Edition (OSE), as
+ * available from http://www.virtualbox.org. This file is free software;
+ * you can redistribute it and/or modify it under the terms of the GNU
+ * General Public License (GPL) as published by the Free Software
+ * Foundation, in version 2 as it comes in the "COPYING" file of the
+ * VirtualBox OSE distribution. VirtualBox OSE is distributed in the
+ * hope that it will be useful, but WITHOUT ANY WARRANTY of any kind.
+ *
+ * The contents of this file may alternatively be used under the terms
+ * of the Common Development and Distribution License Version 1.0
+ * (CDDL) only, as it comes in the "COPYING.CDDL" file of the
+ * VirtualBox OSE distribution, in which case the provisions of the
+ * CDDL are applicable instead of those of the GPL.
+ *
+ * You may elect to license modified versions of this file under the
+ * terms and conditions of either the GPL or the CDDL or both.
+ *
+ * Please contact Sun Microsystems, Inc., 4150 Network Circle, Santa
+ * Clara, CA 95054 USA or visit http://www.sun.com if you need
+ * additional information or have any questions.
+ */
+
+/*******************************************************************************
+*   Header Files                                                               *
+*******************************************************************************/
+#include <iprt/string.h>
+
+
+RTDECL(int) RTStrNLenEx(const char *pszString, size_t cchMax, size_t *pcch)
+{
+    const char *pchEnd = (const char *)memchr(pszString, '\0', cchMax);
+    if (!pchEnd)
+    {
+        *pcch = cchMax;
+        return VERR_BUFFER_OVERFLOW;
+    }
+    *pcch = pchEnd - pszString;
+    return VINF_SUCCESS;
+}
+