Index: trunk/src/VBox/Devices/Graphics/DevVGA.cpp
===================================================================
--- trunk/src/VBox/Devices/Graphics/DevVGA.cpp	(revision 11165)
+++ trunk/src/VBox/Devices/Graphics/DevVGA.cpp	(revision 11166)
@@ -1,6 +1,6 @@
 #ifdef VBOX
-/* $Id: $ */
+/* $Id$ */
 /** @file
- * VBox VGA/VESA device
+ * DevVGA - VBox VGA/VESA device.
  */
 
Index: trunk/src/VBox/Devices/Graphics/DevVGA.h
===================================================================
--- trunk/src/VBox/Devices/Graphics/DevVGA.h	(revision 11165)
+++ trunk/src/VBox/Devices/Graphics/DevVGA.h	(revision 11166)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /** @file
- * VBox VGA/VESA device
+ * DevVGA - VBox VGA/VESA device, internal header.
  */
 
Index: trunk/src/VBox/Devices/Graphics/DevVGAModes.h
===================================================================
--- trunk/src/VBox/Devices/Graphics/DevVGAModes.h	(revision 11165)
+++ trunk/src/VBox/Devices/Graphics/DevVGAModes.h	(revision 11166)
@@ -1,7 +1,8 @@
+/* $Id$ */
 /** @file
+ * DevVGA - VBox VGA/VESA device, VBE modes.
  *
- * VBox VGA/VESA device:
  * List of static mode information, containing all "supported" VBE
- * modes and their 'settings'
+ * modes and their 'settings'.
  */
 
Index: trunk/src/VBox/Devices/Graphics/DevVGATmpl.h
===================================================================
--- trunk/src/VBox/Devices/Graphics/DevVGATmpl.h	(revision 11165)
+++ trunk/src/VBox/Devices/Graphics/DevVGATmpl.h	(revision 11166)
@@ -1,5 +1,5 @@
+/* $Id: $ */
 /** @file
- *
- * VBox VGA/VESA device
+ * DevVGA - VBox VGA/VESA device, code templates.
  */
 
@@ -47,11 +47,11 @@
 #if DEPTH == 8
 #define BPP 1
-#define PIXEL_TYPE uint8_t 
+#define PIXEL_TYPE uint8_t
 #elif DEPTH == 15 || DEPTH == 16
 #define BPP 2
-#define PIXEL_TYPE uint16_t 
+#define PIXEL_TYPE uint16_t
 #elif DEPTH == 32
 #define BPP 4
-#define PIXEL_TYPE uint32_t 
+#define PIXEL_TYPE uint32_t
 #else
 #error unsupport depth
@@ -60,7 +60,7 @@
 #if DEPTH != 15
 
-static inline void glue(vga_draw_glyph_line_, DEPTH)(uint8_t *d, 
+static inline void glue(vga_draw_glyph_line_, DEPTH)(uint8_t *d,
                                                      uint32_t font_data,
-                                                     uint32_t xorcol, 
+                                                     uint32_t xorcol,
                                                      uint32_t bgcol)
 {
@@ -90,5 +90,5 @@
 {
     uint32_t font_data, xorcol;
-    
+
     xorcol = bgcol ^ fgcol;
     do {
@@ -105,13 +105,13 @@
 {
     uint32_t font_data, xorcol;
-    
+
     xorcol = bgcol ^ fgcol;
     do {
         font_data = font_ptr[0];
-        glue(vga_draw_glyph_line_, DEPTH)(d, 
-                                          expand4to8[font_data >> 4], 
+        glue(vga_draw_glyph_line_, DEPTH)(d,
+                                          expand4to8[font_data >> 4],
                                           xorcol, bgcol);
-        glue(vga_draw_glyph_line_, DEPTH)(d + 8 * BPP, 
-                                          expand4to8[font_data & 0x0f], 
+        glue(vga_draw_glyph_line_, DEPTH)(d + 8 * BPP,
+                                          expand4to8[font_data & 0x0f],
                                           xorcol, bgcol);
         font_ptr += 4;
@@ -121,9 +121,9 @@
 
 static void glue(vga_draw_glyph9_, DEPTH)(uint8_t *d, int linesize,
-                                          const uint8_t *font_ptr, int h, 
+                                          const uint8_t *font_ptr, int h,
                                           uint32_t fgcol, uint32_t bgcol, int dup9)
 {
     uint32_t font_data, xorcol, v;
-    
+
     xorcol = bgcol ^ fgcol;
     do {
@@ -137,5 +137,5 @@
         else
             ((uint8_t *)d)[8] = bgcol;
-        
+
 #elif BPP == 2
         cpu_to_32wu(((uint32_t *)d)+0, (dmask4[(font_data >> 6)] & xorcol) ^ bgcol);
@@ -168,8 +168,8 @@
 }
 
-/* 
+/*
  * 4 color mode
  */
-static void glue(vga_draw_line2_, DEPTH)(VGAState *s1, uint8_t *d, 
+static void glue(vga_draw_line2_, DEPTH)(VGAState *s1, uint8_t *d,
                                          const uint8_t *s, int width)
 {
@@ -212,8 +212,8 @@
 #endif
 
-/* 
+/*
  * 4 color mode, dup2 horizontal
  */
-static void glue(vga_draw_line2d2_, DEPTH)(VGAState *s1, uint8_t *d, 
+static void glue(vga_draw_line2d2_, DEPTH)(VGAState *s1, uint8_t *d,
                                            const uint8_t *s, int width)
 {
@@ -247,8 +247,8 @@
 }
 
-/* 
+/*
  * 16 color mode
  */
-static void glue(vga_draw_line4_, DEPTH)(VGAState *s1, uint8_t *d, 
+static void glue(vga_draw_line4_, DEPTH)(VGAState *s1, uint8_t *d,
                                          const uint8_t *s, int width)
 {
@@ -279,8 +279,8 @@
 }
 
-/* 
+/*
  * 16 color mode, dup2 horizontal
  */
-static void glue(vga_draw_line4d2_, DEPTH)(VGAState *s1, uint8_t *d, 
+static void glue(vga_draw_line4d2_, DEPTH)(VGAState *s1, uint8_t *d,
                                            const uint8_t *s, int width)
 {
@@ -311,10 +311,10 @@
 }
 
-/* 
+/*
  * 256 color mode, double pixels
  *
  * XXX: add plane_mask support (never used in standard VGA modes)
  */
-static void glue(vga_draw_line8d2_, DEPTH)(VGAState *s1, uint8_t *d, 
+static void glue(vga_draw_line8d2_, DEPTH)(VGAState *s1, uint8_t *d,
                                            const uint8_t *s, int width)
 {
@@ -334,10 +334,10 @@
 }
 
-/* 
+/*
  * standard 256 color mode
  *
  * XXX: add plane_mask support (never used in standard VGA modes)
  */
-static void glue(vga_draw_line8_, DEPTH)(VGAState *s1, uint8_t *d, 
+static void glue(vga_draw_line8_, DEPTH)(VGAState *s1, uint8_t *d,
                                          const uint8_t *s, int width)
 {
@@ -366,8 +366,8 @@
 /* XXX: optimize */
 
-/* 
+/*
  * 15 bit color
  */
-static void glue(vga_draw_line15_, DEPTH)(VGAState *s1, uint8_t *d, 
+static void glue(vga_draw_line15_, DEPTH)(VGAState *s1, uint8_t *d,
                                           const uint8_t *s, int width)
 {
@@ -388,11 +388,11 @@
         d += BPP;
     } while (--w != 0);
-#endif    
-}
-
-/* 
+#endif
+}
+
+/*
  * 16 bit color
  */
-static void glue(vga_draw_line16_, DEPTH)(VGAState *s1, uint8_t *d, 
+static void glue(vga_draw_line16_, DEPTH)(VGAState *s1, uint8_t *d,
                                           const uint8_t *s, int width)
 {
@@ -413,11 +413,11 @@
         d += BPP;
     } while (--w != 0);
-#endif    
-}
-
-/* 
+#endif
+}
+
+/*
  * 24 bit color
  */
-static void glue(vga_draw_line24_, DEPTH)(VGAState *s1, uint8_t *d, 
+static void glue(vga_draw_line24_, DEPTH)(VGAState *s1, uint8_t *d,
                                           const uint8_t *s, int width)
 {
@@ -442,8 +442,8 @@
 }
 
-/* 
+/*
  * 32 bit color
  */
-static void glue(vga_draw_line32_, DEPTH)(VGAState *s1, uint8_t *d, 
+static void glue(vga_draw_line32_, DEPTH)(VGAState *s1, uint8_t *d,
                                           const uint8_t *s, int width)
 {
@@ -476,9 +476,9 @@
 #ifdef VBOX
 static
-#endif/* VBOX */ 
-void glue(vga_draw_cursor_line_, DEPTH)(uint8_t *d1, 
-                                        const uint8_t *src1, 
+#endif/* VBOX */
+void glue(vga_draw_cursor_line_, DEPTH)(uint8_t *d1,
+                                        const uint8_t *src1,
                                         int poffset, int w,
-                                        unsigned int color0, 
+                                        unsigned int color0,
                                         unsigned int color1,
                                         unsigned int color_xor)
Index: trunk/src/VBox/Devices/PC/DevACPI.cpp
===================================================================
--- trunk/src/VBox/Devices/PC/DevACPI.cpp	(revision 11165)
+++ trunk/src/VBox/Devices/PC/DevACPI.cpp	(revision 11166)
@@ -1,5 +1,5 @@
 /* $Id$ */
 /** @file
- * Advanced Configuration and Power Interface (ACPI) Device.
+ * DevACPI - Advanced Configuration and Power Interface (ACPI) Device.
  */
 